// Learn TypeScript:
//  - https://docs.cocos.com/creator/manual/en/scripting/typescript.html
// Learn Attribute:
//  - https://docs.cocos.com/creator/manual/en/scripting/reference/attributes.html
// Learn life-cycle callbacks:
//  - https://docs.cocos.com/creator/manual/en/scripting/life-cycle-callbacks.html

const {ccclass, property} = cc._decorator;

const LOGIN_BUNDLE_NAME1 = "login1";
const LOGIN_BUNDLE_NAME2 = "login2";
const LOGIN_BUNDLE_NAME3 = "login3";

@ccclass
export default class NewClass extends cc.Component {

    @property(cc.Label)
    label: cc.Label = null;

    @property
    text: string = 'hello';

    // LIFE-CYCLE CALLBACKS:

    // onLoad () {}

    async start () {
        await this.loadLogin1();
        await this.loadLogin2();
        await this.loadLogin3();

        cc.director.loadScene(LOGIN_BUNDLE_NAME2)
    }

    // update (dt) {}

    private loadLogin1(): Promise<boolean> {
        return new Promise(async resolve => {

            cc.assetManager.loadBundle(LOGIN_BUNDLE_NAME1, async (err, bundle: cc.AssetManager.Bundle) => {
                if (err) {
                    cc.error(err.message)
                    return resolve(false)
                }
                bundle.loadDir('/', (err, assets: cc.Asset[]) => {
                    if (err) {
                        cc.error(err.message)
                        return resolve(false)
                    }
                    cc.log("login1 succ")
                    resolve(true)
                })
            })
        })
    }
    private loadLogin2(): Promise<boolean> {
        return new Promise(async resolve => {

            cc.assetManager.loadBundle(LOGIN_BUNDLE_NAME2, async (err, bundle: cc.AssetManager.Bundle) => {
                if (err) {
                    cc.error(err.message)
                    return resolve(false)
                }
                bundle.loadDir('/', (err, assets: cc.Asset[]) => {
                    if (err) {
                        cc.error(err.message)
                        return resolve(false)
                    }
                    cc.log("login2 succ")
                    resolve(true)
                })
            })
        })
    }
    private loadLogin3(): Promise<boolean> {
        return new Promise(async resolve => {

            cc.assetManager.loadBundle(LOGIN_BUNDLE_NAME3, async (err, bundle: cc.AssetManager.Bundle) => {
                if (err) {
                    cc.error(err.message)
                    return resolve(false)
                }
                bundle.loadDir('/', (err, assets: cc.Asset[]) => {
                    if (err) {
                        cc.error(err.message)
                        return resolve(false)
                    }
                    cc.log("login3 succ")
                    resolve(true)
                })
            })
        })
    }
}
